program syntop
  ! syntop n1=100 n2=100 > hh.H
  !
  ! make altitude map
  !%
  use sep
  use triangle
  use random_mod

  implicit none
  integer                            :: n1, n2, nm, i1, i2, stat
  real, dimension (:,:), allocatable :: hh
  real, dimension (:)  , allocatable :: s1, s2, m1, m2
 
  call sep_init ()
  call from_par ("n1", n1, 100)
  call from_par ("n2", n2, 100) ; nm = 35*n2

  call to_history ("n3"   , 1)
  call to_history ("esize", 4)
  call sep_close ()

  allocate (hh(n1,n2), s1(nm), s2(nm), m1 (nm), m2 (nm))

  call random_init (1993)
  do i1 = 1, 35*n2
     call random (s1 (i1), pow = 7)
     call random (s2 (i1), pow = 7)
  end do

  call triangle_init (2, nm)
  stat = triangle_lop (.true., .false., m1, s1)
  call triangle_close ()

  call triangle_init (50, nm)
  stat = triangle_lop (.true., .false., m2, s2)
  call triangle_close ()

  deallocate (s1, s2)

  do i2=1, n2 
     do i1=1 ,n1 
        hh(i1,i2) =              m1 (i2 +2*n2 + i1)
        hh(i1,i2) = hh(i1,i2) +  m2 (i2 +17*n2 - i1*15) * 10.
        hh(i1,i2) = hh(i1,i2) +  cos (i2*.5 - i1*.75) / 500.
     end do
  end do

  call sep_write (hh)

  deallocate (hh, m1, m2)
  call exit (0)
end program syntop


