!	First median bin the data onto a coarse mesh.
!	Then refine the mesh by linear interpolation:
!
!		< xyz.H    Bin2.x median=1 n1=30  n2=30  > coarse.H
!		< coarse.H Refine.x        n1=100 n2=100 > fine.H
!
!	Method:
!	Spray the coarse grid onto pseudoirregular data (data handled
!	in triples although they are regularly spaced).
!	Identify dense points as values on a fine mesh.
!%
program zyxabc
implicit none
integer n1,m1, n2,m2
integer hetch, putch
call initpar() 
if (0==hetch('n1','d',m1))then 
  call seperr('Could not obtain n1 from history')
end if
if (0/=putch('From history: n1','d',m1))then 
  call seperr('trouble writing n1 to history file')
end if
if (0==hetch('n2','d',m2))then 
  call seperr('Could not obtain n2 from history')
end if
if (0/=putch('From history: n2','d',m2))then 
  call seperr('trouble writing n2 to history file')
end if
from par	integer    n1,    n2
call doit ( m1,m2, n1,n2)
end program zyxabc 
subroutine doit( m1,m2, n1,n2)
implicit none
integer i1,i2,   m1,m2, n1,n2
real o1,o2,d1,d2, xmin,xmax, ymin,ymax
integer getch, putch
if (0==getch('o1','f',o1))then 
  call seperr('Could not obtain o1 from par')
end if
if (0/=putch('From par: o1','f',o1))then 
  call seperr('trouble writing o1 to history file')
end if
if (0==getch('o2','f',o2))then 
  call seperr('Could not obtain o2 from par')
end if
if (0/=putch('From par: o2','f',o2))then 
  call seperr('trouble writing o2 to history file')
end if
if (0==getch('d1','f',d1))then 
  call seperr('Could not obtain d1 from par')
end if
if (0/=putch('From par: d1','f',d1))then 
  call seperr('trouble writing d1 to history file')
end if
if (0==getch('d2','f',d2))then 
  call seperr('Could not obtain d2 from par')
end if
if (0/=putch('From par: d2','f',d2))then 
  call seperr('trouble writing d2 to history file')
end if
xmin = o1-d1/2 
xmax = o1 +d1*(m1-1) +d1/2	       ! Great formula!
ymin = o2-d2/2 
ymax = o2 +d2*(m2-1) +d2/2
d1= (xmax-xmin)/n1 
o1= (xmin*(n1-.5) + xmax/2)/n1    ! Great formula!
d2= (ymax-ymin)/n2 
o2= (ymin*(n2-.5) + ymax/2)/n2
if (0/=putch('o1','f',o1))then 
  call seperr('Could not write o1 to history')
end if
if (0/=putch('d1','f',d1))then 
  call seperr('Could not write d1 to history')
end if
if (0/=putch('o2','f',o2))then 
  call seperr('Could not write o2 to history')
end if
if (0/=putch('d2','f',d2))then 
  call seperr('Could not write d2 to history')
end if
call hclose()
do i2=1,n2  
  y = o2 + d2*(i2-1)
  do i1=1,n1  
    x = o1 + d1*(i1-1)
    id = i1+n1*(i2-1)
    xy( id, 1) = x
    xy( id, 2) = y
  end do 
end do 
call sreed( 'in', mm, m1*m2*4)
call lintr2( 0,0, o1,d1,o2,d2, xy, mm,m1,m2, dd,nd)
call srite( 'in', dd, n1*n2*4)
return 
end 
