/* subroutine to sort an array of pointers
   p[m to n] are sorted so that
   x[p[m]] <= x[p[m+1]] <= ... <= x[p[n]]  
   based on Hoare's algorithm (1961, CACM, v.4, p.321). */
psort_(x,p,m,n)
int *p,*m,*n;
float *x;
{
	psort(x,p,*m,*n);
	}

psort (x,p,m,n)
int *p,m,n;
float *x;
  {
	int i,j;

	if (m < n)
	  {
		ppart (x,p,m,n,&i,&j);
		psort (x,p,m,j);
		psort (x,p,i,n);
	  }
  }

ppart (x,p,m,n,pi,pj)
int *p,m,n,*pi,*pj;
float *x;
  {
	int i,j,f,g;
	float xx;

	f = n;
	xx = x[p[f]];
	i = m;
	j = n;
  	up:	for (i = i; i <= n; i++)
			if (xx < x[p[i]])
				goto down;
		i = n;
 	
	down:	for (j = j; j >= m; j--)
			if (x[p[j]] < xx)
				goto change;
		j = m;

	change:	if (i < j)
		  {
			exchge (&p[i],&p[j]);
			i++;
			j--;
			goto up;
		  }
		else if (i < f)
		  {
			exchge (&p[i],&p[f]);
			i++;
		  }
		else if (f < j)
		  {
			exchge (&p[f],&p[j]);
			j--;
		  }

	*pi = i; *pj = j;
  }

int random (m,n)
int m,n;
  {
	int rand();
	float r;
	r = rand();
	r = m + (n - m) * r / 2147483647.;
	return ((int)r);
  }
	
exchge (pa,pb)
int *pa,*pb;
  {
	int temp;
	temp = *pa; *pa = *pb; *pb = temp;
  }
