program Held
  use helderiv
  use helicon
  use sep

  implicit none
  integer                          :: na, stat, n1, n2, n12, i3, n3
  logical                          :: hel
  real                             :: eps
  real, dimension (:), allocatable :: pp, qq
  type( filter)                    :: aa

  call sep_init (SOURCE)
  call from_history (n1, n2, n3)
  call from_par ("helix",hel,.true.)
  call from_par ("na", na, 16)
  call from_par ("eps", eps, 0.001)
  call sep_close ()

  n12 = n1*n2
  allocate (pp(n12), qq(n12))

  if (hel) then
     call helderiv_init (n1, na, eps) 
     do i3=1,n3
        call sep_read ( pp)
	stat = helderiv_lop (.false.,.false., pp, qq)
        call sep_write( qq)
	enddo
     call helderiv_close ()
  else 
     call allocatehelix( aa, 1)
     aa%flt( 1) = -1.
     aa%lag( 1) =  1
     call helicon_init (aa) 
     do i3=1,n3
        call sep_read ( pp)
        stat = helicon_lop (.false.,.false., pp, qq)
        call sep_write( qq)
	enddo
     call deallocatehelix( aa)
  end if

  deallocate (pp, qq)
  call exit (0)
end program Held
