module mad_routines  
  use chain0_mod
  use lint2
  use icai1
  implicit none
  integer, save          :: ndata,add,stat
  real, save,pointer, dimension(:)           :: gmat
  real, save,pointer, dimension(:)       :: temp1
contains
  subroutine madchain_init( gmat_in, ndat_in)
    real, pointer :: gmat_in(:)
    integer ndat_in
    write(0,*) 'MADCHAIN.MADCHAIN_INIT'
    ndata = ndat_in					! "Constructor";
    allocate( temp1(ndata))
    gmat => gmat_in					! "logical link"
  end subroutine madchain_init
  integer function madchain_exec( adj, add, model, data)
    logical       :: adj, add
    real          :: data(:), model(:)
    call chain20( g_oper,icai1_lop,adj, add, model, data,temp1)
    madchain_exec =0
  end function madchain_exec
  integer function g_oper( adj, add, model, data)
    logical       :: adj, add
    real          :: data(:),model(:)
    integer				:: i
    call adjnull(adj,add,model,data)
    !			write(0,*) 'GOOMASK.G_OPER',maxval(gmat),minval(gmat)
    if ( .not. adj) then
       data =				data + model*gmat
    else
       model=				model+ data*gmat
    end if
    g_oper=0
  end function g_oper

  subroutine detrend(model_1D_in,m1,m2,trend_1D)
    real,   dimension(:),pointer       ::model_1D_in,trend_1D
    real,    dimension( :,:)           :: model_2D,trend_2D
    integer                            ::m1,m2,im1,im2
    real                               ::tot,nonzero
    allocate(model_2D(m1,m2),trend_2D(m1,m2)) ! detrend
    model_2D=reshape(model_1D_in,(/m1,m2/))
    tot=0.
    nonzero=0.
    do im1=1,m1
       do im2=1,m2
          if (model_2D(im1,im2).ne.0.) then
             !remove north-south trend
             trend_2D(im1,im2)=(m1-im1)*120
             !remove east-west trend
             trend_2D(im1,im2)=trend_2D(im1,im2)+(m2-im2)*30  
             tot=tot+model_2D(im1,im2)
             nonzero=nonzero+1.
          end if
       end do
    end do
    trend_2D=trend_2D-tot/nonzero  !subtract the average
    where (model_2D.ne.0.) model_2D=model_2D-trend_2D  !subtract the trend
    ! where (model_2D.ne.0.) model_2D=model_2D-tot/nonzero  !subtract the average
    model_1D_in=reshape(model_2D,(/size(model_2D)/))
       trend_1D=reshape(trend_2D,(/size(trend_2D)/))
    deallocate(model_2D)
  end subroutine detrend


end module mad_routines
