! <in.H  Burstnoise  > out.H
!
use sep
use random_mod

implicit none

integer 				:: n1, n2, n3, i3, i2
real, dimension (:), allocatable	:: data, noise
real					:: sigma

call sep_init ()
call from_history (n1)
call from_history ("n2",n2,1)
call from_history ("n3",n3,1)
call from_par ("sigma",sigma,1.)
call sep_close ()

allocate (data(n1)) 
allocate (noise(n1))

do i3=1,n3 
	do i2=1,n2 
		call sep_read(data)
		call getnoise(sigma, noise)
		data = data + noise
		call sep_write (data)
	end do
end do

deallocate (data, noise)
call exit (0)

contains

subroutine getnoise (sigma, noise)

real, intent (in)			:: sigma
real, dimension (:), intent (out)	:: noise

real					:: rand
integer					:: i, j

call random_init (121094)

i = 1
do while (i <= size (noise))
	call random (rand)
	if (rand < .93 ) then 		! no noise
		noise (i) = 0.
		i = i + 1
	else 
		do j = i, size (noise)
			call random (rand)
			noise (j) = sigma * rand
			call random (rand)
			if (rand < .40) exit
		end do
		i = j + 1
	end if
end do

end subroutine getnoise

end
