! <in.H  Despike  niter=10 wide=7 > out.H
!
use sep
use quantile_mod

implicit none
integer 	:: n1, niter, wide
real, dimension (:), allocatable :: data, signal

call sep_init ()
call from_history (n1)

allocate (data(n1))
allocate (signal(n1))

call from_par ("niter",niter,10)
call from_par ("wide",wide,7)
call sep_close()

call sep_read (data)

call slidedespike (wide, data, signal)

call sep_write (signal)

deallocate (data, signal)
call exit (0) 

contains

! Slide a despikeing algorithm along a signal.
!
subroutine slidedespike (wide, dd, mean)

integer, intent (in)			:: wide
real, dimension (:), intent (in)	:: dd
real, dimension (:), intent (out)	:: mean

integer					:: i, n, ishift

n = size (dd)
do i= 1, n
	ishift = max (0, min (n-wide, i-wide/2 - 1))
	mean (i) = quantile (1+wide/2, dd (ishift + 1 : ishift + wide))
end do

end subroutine slidedespike

end
