program Maskinv
  ! < scans.H Seasat.x  > topo.H
  !	find the topo map from the satellite scans
  !%
  use sep
  use createhelixmod
  use bound
  use misinput
  use pef
  use compress
  use print
  use mask2i

  implicit none 
  integer, dimension (2)          :: n, a, b
  integer		          :: niter, n12
  real,    dimension (:), pointer :: dd, hh
  logical, dimension (:), pointer :: known
  type( filter)                   :: aa1, aa2, aa3

  call sep_init ()
  call from_par ("niter", niter, 80)

  call from_history (n); n12 = product (n) 
  call to_history ("n3",4)

  call from_par ("a", a, (/ 7, 7 /))
  call from_par ("b", b, (/ 7, 4 /))
  call sep_close()

  allocate (dd (n12), known (n12))
  call sep_read (dd) 
  known = (dd /= 0.) 

  aa1 = createhelix( n, (/ 1,1 /), (/ 0, 0 /), (/ a(1), 1 /))
  aa2 = createhelix( n, (/ 1,1 /), (/ 0, 0 /), (/ 1, a(2) /))
  aa3 = createhelix( n, (/ 1 + b(1)/2, 1 /), (/ 0, 0 /), b)
  
  call boundn ( n, n, a, aa1);  call find_mask( known, aa1) 
  call boundn ( n, n, a, aa2);  call find_mask( known, aa2) 
  call boundn ( n, n, a, aa3);  call find_mask( known, aa3) 
      

	write(0,*) "lets see",aa1%lag
	write(0,*) "lets see",aa1%flt
  call find_pef ( dd, aa1, size( aa1%lag) * 2); call resize (aa1)
  call find_pef ( dd, aa2, size( aa2%lag) * 2); call resize (aa2)
  call find_pef ( dd, aa3, size( aa3%lag) * 2); call resize (aa3)
  
  call printn( n, (/ 1,1 /), (/ a(1), 1 /), aa1)
  call printn( n, (/ 1,1 /), (/ 1, a(2) /), aa2)
  call printn( n, (/ 1 + b(1)/2, 1 /), b, aa3)

  allocate (hh (n12))
  call maski (niter, dd, hh, known, aa1);      call sep_write (hh)
  call maski (niter, dd, hh, known, aa2);      call sep_write (hh)
  call maski (niter, dd, hh, known, aa1, aa2); call sep_write (hh)
  call maski (niter, dd, hh, known, aa3);      call sep_write (hh)

  deallocate (dd, hh, known)
  call deallocatehelix (aa1)
  call deallocatehelix (aa2)
  call deallocatehelix (aa3)
  call exit (0)
end program Maskinv
