! < hh.H syntrack n1=100 n2=100 n3=2 > data.H
!
!	Make synthetic satellite tracks from topo map.
!%
use sep
use random_mod

implicit none
integer					:: n1, n2,  i1, i2
real, dimension (:), allocatable	:: s1, s2
real, dimension (:,:), allocatable	:: hh
real					:: scale

call sep_init ()
call from_history (n1, n2)
allocate (hh(n1,n2), s1(n1), s2(n2))

call from_par ("scale", scale, .1)
call sep_close ()

call sep_read (hh) 

call random_init (1993)
call random (s2)
call random (s1)

do i1=1,n1
do i2=1,n2
	if( i1**2 + i2**2 > ((n1/2)**2 + (n2/2)**2)/2 ) then
		if( s2(i2)>.15 .and. &
		    s1(i1)>.15)		hh(i1,i2) = 0.0
	end if
end do
end do

call sep_write (hh) 	! north going track
deallocate (hh, s1, s2)
call exit (0) 
end

