program Clip
  use sep

  implicit none
  integer                             :: n1, n2 
  real,    dimension (:), allocatable :: x, y, z, r
  logical, dimension (:), allocatable :: m
  real                                :: c
  character                           :: cut

  call sep_init ()
  call from_history (n1,n2)
  if (n2 /= 3) call erexit ("n2 /= 3")
  call from_par ("clip",c)
  call from_par ("cut",cut, "h")

  allocate (x (n1), y (n1) , z(n1), m (n1))

  call sep_read (x)
  call sep_read (y)
  call sep_read (z)

  if (exist_file ("ref")) then
     allocate (r (n1))
     call sep_read (r, "ref")
     if (cut == "h") then
        m = (r <= c)
     else
        m = (r >= c)
     end if
     deallocate (r)
  else
     if (cut == "h") then
        m = (z <= c)
     else
        m = (z >= c)
     end if
  end if

  call to_history ("n1", count (m))
  call sep_close ()

  call sep_write (pack (x, m))
  call sep_write (pack (y, m))
  call sep_write (pack (abs (z -c), m))
  
  deallocate (x, y, z, m)
  call exit (0)
end program Clip







