program Runmed
  !  <in.H Runmed.x nmed=5 > out.H
  !     
  use quantile_mod
  use sep

  implicit none
  integer                                    :: nc, nd, id, nmed, nh, md, i
  real 	                                     :: thresh
  real, dimension (:,:), allocatable, target :: xyz
  real, dimension (:),   allocatable         :: ww, ss
  real, dimension (:),   pointer             :: x, y, z, rr

  call sep_init ()
  call from_history (nd, nc)
  if ( nc /= 3 .and. nc /= 4) call erexit( 'nc is not 3 or 4')
  call from_par ("nmed", nmed, 5)
  call to_history ("n2", 4)

  allocate (xyz (nd, nc), ww(nd), ss(nd))
  x => xyz (:,1)
  y => xyz (:,2)
  z => xyz (:,3)
  ww = 1.

  call sep_read (xyz)

  ss(1) = 0.
  ss(2:) =  (x(2:)-x(:nd-1))**2 + (y(2:)-y(:nd-1))**2
  thresh = quantile ( nd/2, ss) * 16      ! Set thresh = 4 times the median jump.
  call to_history ("thresh", sqrt(thresh))
  call sep_close ()

  id=1
  do while (id<=nd)			! loop over tracks
     if (id == nd) then
        md = 1
     else 
        do i = id, nd
           if ( (x(i)-x(i+1))**2 + (y(i)-y(i+1))**2  > thresh) exit
        end do
        md = i-id+1
     end if
     rr => z (id:id+md-1)
     if( md >= nmed ) then
        nh = nmed/2
        ss (:md) = rr
        do i= 1, md-nmed+1 			! running median 
           ss (i+nh) = quantile( 1+nh, rr (i:i+nmed-1))
        end do
        do i=1,nh
           ww(id:id+nh-1)      = 0.
           ww(id-1+ md-i+1) = 0.
        end do
        z (id:id+md-1) = ss (:md)
     else					! throw away short track.
        ww(id:id+md-1) = 0.
     end if
     id=id+md
  end do

  call sep_write (xyz)
  call sep_write (ww)

  deallocate (xyz, ww, ss)
  call exit (0)
end program Runmed






