module madchain  
  use chain0_mod
  use lint2
  use icai1
  implicit none
  integer, save          :: ndata,add,stat
  real, save,pointer, dimension(:)           :: gmat
  real, save,pointer, dimension(:)       :: temp1
  contains
  subroutine madchain_init( gmat_in, ndat_in)
    real, pointer :: gmat_in(:)
    integer ndat_in
    write(0,*) 'MADCHAIN.MADCHAIN_INIT'
    ndata = ndat_in					! "Constructor";
    allocate( temp1(ndata))
    gmat => gmat_in					! "logical link"
  end subroutine 
  integer function madchain_exec( adj, add, model, data)
    logical       :: adj, add
    real          :: data(:), model(:)
    call chain20( g_oper,icai1_lop,adj, add, model, data,temp1)
    madchain_exec =0
  end function 
  integer function g_oper( adj, add, model, data)
    logical       :: adj, add
    real          :: data(:),model(:)
    integer				:: i
    call adjnull(adj,add,model,data)
    if ( .not. adj) then
      data =				data + model*gmat
    else
      model=				model+ data*gmat
    end if 
    g_oper=0
  end function 
end module 
