module fixbad_mod
  use helix
  use mis_mod
  use quantile_mod
  use icai1

  implicit none

contains

  ! Given a PEF, finds bad data and restores it.
  !
  subroutine fixbad (niter, aa, yy)
    integer, intent (in)	    :: niter
    real,    dimension (:), pointer :: aa
    real,    dimension (:)	    :: yy

    real,    dimension (size (yy))  :: rr
    integer		            :: stat, nr
    real,    dimension (:), pointer :: bb
    integer, dimension (:), pointer :: lag

    nr = size (rr)
    call icai1_init (aa, nr)
    stat = icai1_op (.false., .false., yy, rr) ; rr = abs (rr)

    where (rr > 4 * quantile (0.5, rr)) yy = 0. 
    yy (1 : size (aa)) = 0.

    call helicon (aa, bb, lag)
    call mis_data (niter, nr, yy, bb, lag, 0, .false.)
    deallocate (bb, lag)
  end subroutine fixbad

end module fixbad_mod



