! < hh.H syntrack n1=100 n2=100 n3=2 > data.H
!
!	Make synthetic satellite tracks from topo map.
!%
use sep
use random_mod

implicit none
integer					:: n1, n2,  i1, i2
real, dimension (:), allocatable	:: s1, s2
real, dimension (:,:), allocatable	:: hh, ss, nn
real					:: scale

call sep_init ()
call from_history (n1, n2)
allocate (hh (n1, n2), s1(n1), s2(n2))
allocate (ss (n1, n2))
allocate (nn (n1, n2))

call from_par ("scale", scale, .1)
call to_history ("n3",2)
call sep_close ()

call sep_read (hh) 

call random_init (1993)
call random (s2, scale)
call random (s1, scale)

do i1 = 1, n1
	nn (i1,:) = hh (i1,:) + s2
end do

do i2 = 1, n2
	ss (:,i2) = hh (:,i2) + s1
end do

call random (s2)
call random (s1)

do i1=1,n1
	where (s2 (i1 + 1:) > .1) nn (i1, i1 + 1:) = 0.
end do 

do i2=1,n2
	where (s1 (:i2 - 1) > .1) ss (:i2 - 1, i2) = 0.
end do 

call sep_write (nn) 	! north going track
call sep_write (ss) 	! south going track

deallocate (hh,ss,nn,s1,s2)
call exit (0) 
end

